## carbon-qt 0+p20201123+git20201207.1943

=== CMakeLists.txt ===
project(carbon)
set(PROJECT_VERSION "5.2.90")
set(PROJECT_VERSION_MAJOR 5)
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

include(GenerateExportHeader)
include(WriteBasicConfigVersionFile)
include(FeatureSummary)

set(CARBON_USE_KDE4 ${USE_KDE4})
if(CARBON_USE_KDE4)

  ############ Language and toolchain features
  ############ copied from ECM
  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" AND NOT WIN32)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()

endif()

################# Qt/KDE #################
if(CARBON_USE_KDE4)

  find_package(KDE4 REQUIRED)
  include(KDE4Defaults)
  include(MacroLibrary)

  add_definitions(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})
  include_directories(${KDE4_INCLUDES})

  ### XCB
  find_package(PkgConfig)
  pkg_check_modules(XCB xcb x11-xcb)
  set(CARBON_HAVE_X11 ${XCB_FOUND})

  add_subdirectory(libcarbon)
  add_subdirectory(kstyle)

else()

  find_package(ECM 0.0.9 REQUIRED NO_MODULE)
  set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

  find_package(Qt5 REQUIRED CONFIG COMPONENTS Widgets DBus)
  find_package(KF5 REQUIRED COMPONENTS
      I18n
      Config
      GuiAddons
      WidgetsAddons
      Service
      Completion
      FrameworkIntegration
      WindowSystem)

  find_package(XCB COMPONENTS XCB)
  set_package_properties(XCB PROPERTIES
      DESCRIPTION "X protocol C-language Binding"
      URL "http://xcb.freedesktop.org"
      TYPE OPTIONAL
      PURPOSE "Required to pass style properties to native Windows on X11 Platform"
  )

  if(NOT APPLE)

    set(CARBON_HAVE_X11 ${XCB_XCB_FOUND})
    if (XCB_XCB_FOUND)
      find_package(Qt5 REQUIRED CONFIG COMPONENTS X11Extras)
    endif()

  endif()

  include(KDEInstallDirs)
  include(KDECMakeSettings)
  include(KDECompilerSettings)

  add_subdirectory(libcarbon)
  add_subdirectory(kstyle)

  # po/ dir added by packaging scripts
  if(EXISTS ${CMAKE_SOURCE_DIR}/po AND IS_DIRECTORY ${CMAKE_SOURCE_DIR}/po)
    find_package(KF5I18n CONFIG REQUIRED)
    ki18n_install(po)
  endif()

endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== kstyle/CMakeLists.txt ===
project(kstyle-carbon)

################# includes #################
include_directories(
    animations
    debug
    transitions
)

include_directories(${CMAKE_SOURCE_DIR}/libcarbon)
include_directories(${CMAKE_BINARY_DIR}/libcarbon)

########### next target ###############
set(carbon_PART_SRCS
    animations/carbonanimations.cpp
    animations/carbonanimationdata.cpp
    animations/carbonbaseengine.cpp
    animations/carbonbusyindicatordata.cpp
    animations/carbonbusyindicatorengine.cpp
    animations/carbondockseparatordata.cpp
    animations/carbondockseparatorengine.cpp
    animations/carbonenabledata.cpp
    animations/carbongenericdata.cpp
    animations/carbonheaderviewdata.cpp
    animations/carbonheaderviewengine.cpp
    animations/carbonmdiwindowdata.cpp
    animations/carbonmdiwindowengine.cpp
    animations/carbonmenubardata.cpp
    animations/carbonmenubarengine.cpp
    animations/carbonmenudata.cpp
    animations/carbonmenuengine.cpp
    animations/carbonprogressbardata.cpp
    animations/carbonprogressbarengine.cpp
    animations/carbonscrollbardata.cpp
    animations/carbonscrollbarengine.cpp
    animations/carbonspinboxdata.cpp
    animations/carbonspinboxengine.cpp
    animations/carbonsplitterengine.cpp
    animations/carbontabbardata.cpp
    animations/carbontabbarengine.cpp
    animations/carbontoolbardata.cpp
    animations/carbontoolbarengine.cpp
    animations/carbontoolboxengine.cpp
    animations/carbonwidgetstatedata.cpp
    animations/carbonwidgetstateengine.cpp
    debug/carbonwidgetexplorer.cpp
    transitions/carboncomboboxdata.cpp
    transitions/carboncomboboxengine.cpp
    transitions/carbonlabeldata.cpp
    transitions/carbonlabelengine.cpp
    transitions/carbonlineeditdata.cpp
    transitions/carbonlineeditengine.cpp
    transitions/carbonstackedwidgetdata.cpp
    transitions/carbonstackedwidgetengine.cpp
    transitions/carbontransitiondata.cpp
    transitions/carbontransitions.cpp
    transitions/carbontransitionwidget.cpp
    carbonblurhelper.cpp
    carbonframeshadow.cpp
    carbonmdiwindowshadow.cpp
    carbonmnemonics.cpp
    carbonpropertynames.cpp
    carbonshadowhelper.cpp
    carbonsplitterproxy.cpp
    carbonstyle.cpp
    carbonstylehelper.cpp
    carbonstyleplugin.cpp
    carbonwindowmanager.cpp
)

if(CARBON_USE_KDE4)
  kde4_add_kcfg_files(carbon_PART_SRCS carbonstyleconfigdata.kcfgc)
  kde4_add_plugin(carbon ${carbon_PART_SRCS} kstylekde4compat.cpp)
  target_link_libraries(carbon ${KDE4_KDEUI_LIBS})
  target_link_libraries(carbon carbonstyle)

  if(CARBON_HAVE_X11)
    target_link_libraries(carbon ${X11_XCB_LIBRARIES})
    target_link_libraries(carbon ${XCB_LIBRARIES})
  endif()

  install(TARGETS carbon DESTINATION ${PLUGIN_INSTALL_DIR}/plugins/styles/)

else()

  kconfig_add_kcfg_files(carbon_PART_SRCS carbonstyleconfigdata.kcfgc)
  add_library(carbon MODULE ${carbon_PART_SRCS})

  target_link_libraries(carbon Qt5::Core Qt5::Gui Qt5::Widgets Qt5::DBus)
  target_link_libraries(carbon KF5::GuiAddons KF5::Style KF5::WindowSystem)
  target_link_libraries(carbon carbonstyle5)

  if(CARBON_HAVE_X11)
    target_link_libraries(carbon XCB::XCB)
    target_link_libraries(carbon Qt5::X11Extras)
  endif()

  install(TARGETS carbon DESTINATION ${QT_PLUGIN_INSTALL_DIR}/styles/)

endif()

if(WIN32)
  # As stated in http://msdn.microsoft.com/en-us/library/4hwaceh6.aspx M_PI only gets defined
  # when using MSVC if _USE_MATH_DEFINES is defined (this is needed for angle.cpp)
  target_compile_definitions(carbon PRIVATE _USE_MATH_DEFINES _GNU_SOURCE)
endif()

########### install files ###############
install(FILES carbon.themerc  DESTINATION  ${DATA_INSTALL_DIR}/kstyle/themes)

########### subdirectories ###############
add_subdirectory(config)
add_subdirectory(demo)

=== libcarbon/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"libcarbonstyleconfig\")

################# configuration #################
configure_file(config-libcarbon.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-libcarbon.h)

################# libcarbonstyle #################
set(carbonstyle_LIB_SRCS
    carbonanimation.cpp
    carbonhelper.cpp
    carbonitemmodel.cpp
    carbonshadowcache.cpp
    carbontileset.cpp
    carbonutil.cpp)

if(CARBON_USE_KDE4)

  kde4_add_kcfg_files(carbonstyle_LIB_SRCS
    carbonactiveshadowconfiguration.kcfgc
    carboninactiveshadowconfiguration.kcfgc
 )

  kde4_add_library(carbonstyle SHARED ${carbonstyle_LIB_SRCS})

  generate_export_header(carbonstyle BASE_NAME carbon EXPORT_FILE_NAME carbon_export.h)

  target_link_libraries(carbonstyle ${KDE4_KDEUI_LIBS})

  if(CARBON_HAVE_X11)
    target_link_libraries(carbonstyle ${X11_XCB_LIBRARIES})
    target_link_libraries(carbonstyle ${XCB_LIBRARIES})
  endif()

  set_target_properties(carbonstyle PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

 if(WIN32)
      # As stated in http://msdn.microsoft.com/en-us/library/4hwaceh6.aspx M_PI only gets defined
      # when using MSVC if _USE_MATH_DEFINES is defined (this is needed for angle.cpp)
      target_compile_definitions(carbonstyle PRIVATE _USE_MATH_DEFINES _GNU_SOURCE)
  endif()
  install(TARGETS carbonstyle ${INSTALL_TARGETS_DEFAULT_ARGS})

else()

  kconfig_add_kcfg_files(carbonstyle_LIB_SRCS
    carbonactiveshadowconfiguration.kcfgc
    carboninactiveshadowconfiguration.kcfgc
 )

  add_library(carbonstyle5 ${carbonstyle_LIB_SRCS})

  generate_export_header(carbonstyle5 BASE_NAME carbon EXPORT_FILE_NAME carbon_export.h)

  # NB: although we install no headers, we still need to have a link
  #     interface, since other Carbon targets link to this library
  target_link_libraries(carbonstyle5
      PUBLIC
          Qt5::Core
          Qt5::Gui
          Qt5::Widgets
          KF5::ConfigCore
          KF5::ConfigWidgets
      PRIVATE
          KF5::GuiAddons
 )

  target_include_directories(carbonstyle5 PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

  if(CARBON_HAVE_X11)
      target_link_libraries(carbonstyle5 PRIVATE XCB::XCB Qt5::X11Extras)
  endif()

  set_target_properties(carbonstyle5 PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
  if(WIN32)
      # As stated in http://msdn.microsoft.com/en-us/library/4hwaceh6.aspx M_PI only gets defined
      # when using MSVC if _USE_MATH_DEFINES is defined (this is needed for angle.cpp)
      target_compile_definitions(carbonstyle5 PRIVATE _USE_MATH_DEFINES _GNU_SOURCE)
  endif()
  install(TARGETS carbonstyle5 ${INSTALL_TARGETS_DEFAULT_ARGS})

endif()

################# libcarbonstyleconfig #################
set(carbonstyleconfig_LIB_SRCS
    carbonanimationconfigitem.cpp
    carbonbaseanimationconfigwidget.cpp
    carbongenericanimationconfigitem.cpp
    carbonshadowconfigwidget.cpp
)

set(carbonstyleconfig_LIB_FORMS
    ui/carbonanimationconfigitem.ui
    ui/carbonanimationconfigwidget.ui
    ui/carbongenericanimationconfigbox.ui
    ui/carbonshadowconfigurationui.ui
)

if(CARBON_USE_KDE4)

  kde4_add_ui_files(carbonstyleconfig_LIB_FORMS_HEADERS ${carbonstyleconfig_LIB_FORMS})
  kde4_add_kcfg_files(carbonstyleconfig_LIB_SRCS
      carbonactiveshadowconfiguration.kcfgc
      carboninactiveshadowconfiguration.kcfgc
 )

  kde4_add_library(carbonstyleconfig SHARED
      ${carbonstyleconfig_LIB_SRCS}
      ${carbonstyleconfig_LIB_FORMS_HEADERS})

  generate_export_header(carbonstyleconfig BASE_NAME carbon_config EXPORT_FILE_NAME carbon_config_export.h)

  target_link_libraries(carbonstyleconfig ${KDE4_KDEUI_LIBS})

  set_target_properties(carbonstyleconfig PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
  install(TARGETS carbonstyleconfig ${INSTALL_TARGETS_DEFAULT_ARGS})

  # NB: although we install no headers, we still need to have a link
  #     interface, since other Carbon targets link to this library
  target_link_libraries(carbonstyleconfig carbonstyle)

else()

  ki18n_wrap_ui(carbonstyleconfig_LIB_FORMS_HEADERS ${carbonstyleconfig_LIB_FORMS})

  kconfig_add_kcfg_files(carbonstyleconfig_LIB_SRCS
      carbonactiveshadowconfiguration.kcfgc
      carboninactiveshadowconfiguration.kcfgc
 )

  add_library(carbonstyleconfig5 SHARED
      ${carbonstyleconfig_LIB_SRCS}
      ${carbonstyleconfig_LIB_FORMS_HEADERS})

  generate_export_header(carbonstyleconfig5 BASE_NAME carbon_config EXPORT_FILE_NAME carbon_config_export.h)

  # NB: although we install no headers, we still need to have a link
  #     interface, since other Carbon targets link to this library
  target_link_libraries(carbonstyleconfig5
       PUBLIC
          carbonstyle5
          Qt5::Core
          Qt5::Gui
          Qt5::Widgets
      PRIVATE
          KF5::I18n
 )

  set_target_properties(carbonstyleconfig5 PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
  install(TARGETS carbonstyleconfig5 ${INSTALL_TARGETS_DEFAULT_ARGS})
  # Note: no headers installed

endif()

=== kstyle/config/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"carbon_style_config\")
set(kstyle_carbon_config_PART_SRCS
    carbonanimationconfigwidget.cpp
    carbonfollowmouseanimationconfigitem.cpp
    carbonstyleconfig.cpp
)

set(kstyle_carbon_config_PART_FORMS
    ui/carbonfollowmouseanimationconfigbox.ui
    ui/carbonstyleconfig.ui
)

if(CARBON_USE_KDE4)

  kde4_add_kcfg_files(kstyle_carbon_config_PART_SRCS ../carbonstyleconfigdata.kcfgc)

  kde4_add_ui_files(kstyle_carbon_config_PART_FORMS_HEADERS ${kstyle_carbon_config_PART_FORMS})

  kde4_add_plugin(kstyle_carbon_config
      ${kstyle_carbon_config_PART_SRCS}
      ${kstyle_carbon_config_PART_FORMS_HEADERS}
 )

  target_link_libraries(kstyle_carbon_config ${KDE4_KDEUI_LIBS})
  target_link_libraries(kstyle_carbon_config carbonstyleconfig)
  install(TARGETS kstyle_carbon_config DESTINATION ${PLUGIN_INSTALL_DIR}/)

else()

  set(kstyle_carbon_config_PART_SRCS ${kstyle_carbon_config_PART_SRCS} carbonstyleconfigmodule.cpp)

  kconfig_add_kcfg_files(kstyle_carbon_config_PART_SRCS ../carbonstyleconfigdata.kcfgc)

  set(kstyle_carbon_config_PART_FORMS
    ui/carbonfollowmouseanimationconfigbox.ui
    ui/carbonstyleconfig.ui
 )

  ki18n_wrap_ui(kstyle_carbon_config_PART_FORMS_HEADERS ${kstyle_carbon_config_PART_FORMS})

  add_library(kstyle_carbon_config MODULE
      ${kstyle_carbon_config_PART_SRCS}
      ${kstyle_carbon_config_PART_FORMS_HEADERS}
 )

  target_link_libraries(kstyle_carbon_config Qt5::Core Qt5::Gui Qt5::Widgets Qt5::DBus)
  target_link_libraries(kstyle_carbon_config KF5::Completion KF5::I18n)
  target_link_libraries(kstyle_carbon_config carbonstyleconfig5)

  install(TARGETS kstyle_carbon_config DESTINATION ${QT_PLUGIN_INSTALL_DIR})
  install(FILES carbonstyleconfig.desktop DESTINATION  ${SERVICES_INSTALL_DIR})

endif()

########### next target ###############
set(carbon_settings_SOURCES
    carbonconfigdialog.cpp
    main.cpp)

set(carbon_settings_FORMS ui/carbonconfigdialog.ui)

if(CARBON_USE_KDE4)

  kde4_add_ui_files(carbon_settings_SOURCES ${carbon_settings_FORMS})
  kde4_add_executable(carbon-settings ${carbon_settings_SOURCES})
  target_link_libraries(carbon-settings ${KDE4_KDEUI_LIBS})
  target_link_libraries(carbon-settings ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})

  install(TARGETS carbon-settings ${INSTALL_TARGETS_DEFAULT_ARGS})

else()

  ki18n_wrap_ui(carbon_settings_FORMS_HEADERS ${carbon_settings_FORMS})

  add_executable(carbon-settings5
      ${carbon_settings_SOURCES}
      ${carbon_settings_FORMS_HEADERS}
 )

  target_link_libraries(carbon-settings5 Qt5::Core Qt5::Gui Qt5::Widgets Qt5::DBus)
  target_link_libraries(carbon-settings5 KF5::I18n KF5::WidgetsAddons KF5::ConfigCore KF5::ConfigGui KF5::Service)

  install(TARGETS carbon-settings5 ${INSTALL_TARGETS_DEFAULT_ARGS})

endif()

=== kstyle/demo/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"carbon_style_demo\")

include_directories(${CMAKE_BINARY_DIR}/libcarbon)

########### next target ###############
set(carbon_demo_SOURCES
    carbonbenchmarkwidget.cpp
    carbonbuttondemowidget.cpp
    carbondemodialog.cpp
    carbondemowidget.cpp
    carbonframedemowidget.cpp
    carboninputdemowidget.cpp
    carbonlistdemowidget.cpp
    carbonmdidemowidget.cpp
    carbonsimulator.cpp
    carbonsliderdemowidget.cpp
    carbontabdemowidget.cpp
    carbontabwidget.cpp
    main.cpp)

set(carbon_demo_FORMS
    ui/carbonbenchmarkwidget.ui
    ui/carbonbuttondemowidget.ui
    ui/carbondemodialog.ui
    ui/carbonframedemowidget.ui
    ui/carboninputdemowidget.ui
    ui/carbonlistdemowidget.ui
    ui/carbonmdidemowidget.ui
    ui/carbonsliderdemowidget.ui
    ui/carbontabdemowidget.ui
)

if(CARBON_USE_KDE4)

  kde4_add_ui_files(carbon_demo_FORMS_HEADERS ${carbon_demo_FORMS})

  kde4_add_executable(carbon-demo
      ${carbon_demo_SOURCES}
      ${carbon_demo_FORMS_HEADERS}
 )

  target_link_libraries(carbon-demo ${KDE4_KDEUI_LIBS})

  ########### install files ###############
  install(TARGETS carbon-demo ${INSTALL_TARGETS_DEFAULT_ARGS})

else()

  ki18n_wrap_ui(carbon_demo_FORMS_HEADERS ${carbon_demo_FORMS})

  add_executable(carbon-demo5
      ${carbon_demo_SOURCES}
      ${carbon_demo_FORMS_HEADERS}
 )

  target_link_libraries(carbon-demo5 Qt5::Core Qt5::Gui Qt5::Widgets)
  target_link_libraries(carbon-demo5 KF5::Completion KF5::ConfigGui KF5::WidgetsAddons KF5::I18n)

  ########### install files ###############
  install(TARGETS carbon-demo5 ${INSTALL_TARGETS_DEFAULT_ARGS})

endif()

=== debian/changelog ===
carbon-qt (0+p20201123+git20201207.1943-0) 2101+amd64; urgency=medium

  * Automatic Debian CI Build

 -- Debian CI <null@debian.org>  Mon, 07 Dec 2020 19:43:27 +0000

carbon-qt (0-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Rohan Garg <rohan@kde.org>  Mon, 25 Jul 2016 16:15:32 +0200

=== debian/control ===
Source: carbon-qt
Section: unknown
Priority: optional
Maintainer: Rohan Garg <rohan@kde.org>
Build-Depends: cmake,
               debhelper (>= 9),
               extra-cmake-modules,
               kdelibs5-dev,
               libkf5completion-dev,
               libkf5config-dev,
               libkf5guiaddons-dev,
               libkf5i18n-dev,
               libkf5service-dev,
               libkf5style-dev,
               libkf5widgetsaddons-dev,
               libkf5windowsystem-dev,
               libqt4-dev,
               libqt5x11extras5-dev,
               libxcb1-dev,
               pkg-config,
               pkg-kde-tools
Standards-Version: 3.9.8
Homepage: https://github.com/ds9-extras/carbon-qt/
Vcs-Git: https://github.com/dci-extras-packaging/carbon-qt
Vcs-Browser: https://github.com/dci-extras-packaging/carbon-qt

Package: carbon-qt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: carbon-qt theme
 This package contains the carbon-qt theme

Package: carbon-qt4
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: carbon-qt4 theme
 This package contains the carbon-qt4 theme

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CURDIR)/build-qt4

override_dh_auto_configure:
	dh_auto_configure
	dh_auto_configure --builddirectory=$(CURDIR)/build-qt4 -- -DCARBON_USE_KDE4=true

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=$(CURDIR)/build-qt4

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=$(CURDIR)/build-qt4
